package ajedrez.server.dominio;

import java.lang.reflect.Field;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

import ajedrez.client.comunicaciones.IJugador;
import ajedrez.client.presen.IVentanaTablero;
import ajedrez.server.comunicaciones.AjedrezServer;
import ajedrez.server.persistencia.Metodos;
import ajedrez.server.presen.FVentanaServidor;
import junit.framework.TestCase;


import mockit.Mock;
import mockit.Mockit;


public class TestASJMokitRetarMayor extends TestCase{


	public static class MyRandom{

		@Mock
		public static double random(){
			return 0.8;
		}
	}
	private class StubJugador implements IJugador{

		String name;


		public StubJugador(String n){
			this.name = n;
		}

		@Override
		public void MostrarInfoAbandono() throws RemoteException {
			// TODO Auto-generated method stub

		}


		Vector se = new Vector();
		public void RellenerSalaEspera(Vector arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.addAll(arg0);
		}


		int a1;
		String a2;
		String a3;
		public void actualizar(int arg0, String arg1, String arg2)
		throws RemoteException {
			// TODO Auto-generated method stub
			a1=arg0;
			a2=arg1;
			a3=arg2;
		}

		@Override
		public void borrarJugSalaEspera(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.remove(arg0);
		}

		@Override
		public void cierreForzoso() throws RemoteException {
			// TODO Auto-generated method stub

		}

		int ctR;
		char ctRC;
		@Override
		public void contestarReto(int arg0, char arg1) throws RemoteException {
			// TODO Auto-generated method stub
			ctR=arg0;
			ctRC=arg1;
		}

		boolean ctt;
		@Override
		public void contestarTablas(boolean arg0) throws RemoteException {
			// TODO Auto-generated method stub
			ctt=arg0;
		}

		@Override
		public String getNombre() throws RemoteException {
			// TODO Auto-generated method stub
			return this.name;
		}

		String nJ;
		@Override
		public void mostrarJugadorNuevo(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			nJ=arg0;
		}

		@Override
		public void proponerTablas() throws RemoteException {
			// TODO Auto-generated method stub

		}

		String retar;
		@Override
		public void retar(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			retar = arg0;
		}

		int rc1;
		int rc2;
		char rcC;
		@Override
		public void rivalCorono(int arg0, int arg1, char arg2)
		throws RemoteException {
			// TODO Auto-generated method stub
			rc1 = arg0;
			rc2 = arg1;
			rcC = arg2;
		}

		IVentanaTablero t;
		@Override
		public void setTablero(IVentanaTablero arg0) throws RemoteException {
			// TODO Auto-generated method stub
			t = arg0;
		}

	}

	private AjedrezServer as;
	private FVentanaServidor vs;


	String user1 = "test1";
	String user2 = "test2";
	String pass1 = "pass1";
	String pass2 = "pass2";

	StubJugador j1 = new StubJugador(user1);
	StubJugador j2 = new StubJugador(user2);
	StubJugador j3 = new StubJugador("j3");
	StubJugador j4 = new StubJugador("j4");
	
	protected void setUp(){

		Mockit.setUpMock(Math.class,MyRandom.class);

		try {
			as = new AjedrezServer();
			vs = new FVentanaServidor(as);
			as.identificar(user1, j1);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			as.contestarReto(this.user1, this.user2, true);
			
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 

	}
	
	
	
	
	
	protected void tearDown(){

		Mockit.tearDownMocks(Math.class);

		
	}

	
	public void testRetar(){
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar("j3", j3);
			as.identificar("j4", j4);

			as.contestarReto("j3", "j4", true);

			assertTrue(j3.ctR==j4.ctR);
			assertTrue(j4.ctRC=='n');
			assertTrue(j3.ctRC=='b');

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}


	
}
