package ajedrez.server.dominio.tests;


import ajedrez.server.dominio.Tablero;
import junit.framework.TestCase;

public class ComerAlPAso extends TestCase {

	
	
	public void testPeonComerAlPasoIzquierdaBlancaGH() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 2, 4, 2, "g2", "g4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 2, 5, 2, "g4", "g5");
		t.mover('n', 7, 1, 5, 1, "h7", "h5");
		t.almacenarMovimiento("h7-h5");
		dev = t.mover('b', 5, 2, 6, 1, "g5", "h6");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoIzquierdaBlancaFG() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 3, 5, 3, "f4", "f5");
		t.mover('n', 7, 2, 5, 2, "g7", "g5");
		t.almacenarMovimiento("g7-g5");
		dev = t.mover('b', 5, 3, 6, 2, "f5", "g6");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoIzquierdaBlancaEF() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.almacenarMovimiento("f7-f5");
		dev = t.mover('b', 5, 4, 6, 3, "e5", "f6");
		
		
		super.assertEquals(4, dev);
	}
	
	
	public void testPeonComerAlPasoIzquierdaBlancaDE() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 5, 4, 5, "d2", "d4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 5, 5, 5, "d4", "d5");
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.almacenarMovimiento("e7-e5");
		dev = t.mover('b', 5, 5, 6, 4, "d5", "e6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaBlancaCD() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 6, 4, 6, "c2", "c4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 6, 5, 6, "c4", "c5");
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.almacenarMovimiento("d7-d5");
		dev = t.mover('b', 5, 6, 6, 5, "c5", "d6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaBlancaBC() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 7, 4, 7, "b2", "b4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 7, 5, 7, "b4", "b5");
		t.mover('n', 7, 6, 5, 6, "c7", "c5");
		t.almacenarMovimiento("c7-c5");
		dev = t.mover('b', 5, 7, 6, 6, "b5", "c6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaBlancaAB() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 8, 4, 8, "a2", "a4");
		t.mover('n', 7, 1, 6, 1, "h7", "h6");
		t.mover('b', 4, 8, 5, 8, "a4", "a5");
		t.mover('n', 7, 7, 5, 7, "b7", "b5");
		t.almacenarMovimiento("b7-b5");
		dev = t.mover('b', 5, 8, 6, 7, "a5", "b6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaBlancaHG() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 1, 4, 1, "h2", "h4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 1, 5, 1, "h4", "h5");
		t.mover('n', 7, 2, 5, 2, "g7", "g5");
		t.almacenarMovimiento("g7-g5");
		dev = t.mover('b', 5, 1, 6, 2, "h5", "g6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaBlancaGF() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 2, 4, 2, "g2", "g4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 2, 5, 2, "g4", "g5");
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.almacenarMovimiento("f7-f5");
		dev = t.mover('b', 5, 2, 6, 3, "g5", "f6");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoDerechaBlancaFE() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 3, 5, 3, "f4", "f5");
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.almacenarMovimiento("e7-e5");
		dev = t.mover('b', 5, 3, 6, 4, "f5", "e6");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoDerechaBlancaED() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.almacenarMovimiento("d7-d5");
		dev = t.mover('b', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(4, dev);
	}
	
	
	public void testPeonComerAlPasoDerechaBlancaDC() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 5, 4, 5, "d2", "d4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 5, 5, 5, "d4", "d5");
		t.mover('n', 7, 6, 5, 6, "c7", "c5");
		t.almacenarMovimiento("c7-c5");
		dev = t.mover('b', 5, 5, 6, 6, "d5", "c6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaBlancaCB() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 6, 4, 6, "c2", "c4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 6, 5, 6, "c4", "c5");
		t.mover('n', 7, 7, 5, 7, "b7", "b5");
		t.almacenarMovimiento("b7-b5");
		dev = t.mover('b', 5, 6, 6, 7, "c5", "b6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaBlancaBA() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 7, 4, 7, "b2", "b4");
		t.mover('n', 7, 1, 6, 1, "h7", "h6");
		t.mover('b', 4, 7, 5, 7, "b4", "b5");
		t.mover('n', 7, 8, 5, 8, "a7", "a5");
		t.almacenarMovimiento("a7-a5");
		dev = t.mover('b', 5, 7, 6, 8, "b5", "a6");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraGH() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 2, 5, 2, "g7", "g5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 2, 4, 2, "g5", "g4");
		t.mover('b', 2, 1, 4, 1, "h2", "h4");
		t.almacenarMovimiento("h2-h4");
		dev = t.mover('n', 4, 2, 3, 1, "g4", "h3");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoIzquierdaNegraFG() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 2, 4, 2, "g2", "g4");
		t.almacenarMovimiento("g2-g4");
		dev = t.mover('n', 4, 3, 3, 2, "f4", "g3");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoIzquierdaNegraEF() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.almacenarMovimiento("f2-f4");
		dev = t.mover('n', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(4, dev);
	}
	
	
	public void testPeonComerAlPasoIzquierdaNegraDE() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 5, 4, 5, "d5", "d4");
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.almacenarMovimiento("e2-e4");
		dev = t.mover('n', 4, 5, 3, 4, "d4", "e3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraCD() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 6, 5, 6, "c7", "c5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 6, 4, 6, "c5", "c4");
		t.mover('b', 2, 5, 4, 5, "d2", "d4");
		t.almacenarMovimiento("d2-d4");
		dev = t.mover('n', 4, 6, 3, 5, "c4", "d3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraBC() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 7, 5, 7, "b7", "b5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 7, 4, 7, "b5", "b4");
		t.mover('b', 2, 6, 4, 6, "c2", "c4");
		t.almacenarMovimiento("c2-c4");
		dev = t.mover('n', 4, 7, 3, 6, "b4", "c3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraAB() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 8, 5, 8, "a7", "a5");
		t.mover('b', 2, 1, 3, 1, "h2", "h3");
		t.mover('n', 5, 8, 4, 8, "a5", "a4");
		t.mover('b', 2, 7, 4, 7, "b2", "b4");
		t.almacenarMovimiento("b2-b4");
		dev = t.mover('n', 4, 8, 3, 7, "a4", "b3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraHG() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 1, 5, 1, "h7", "h5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 1, 4, 1, "h5", "h4");
		t.mover('b', 2, 2, 4, 2, "g2", "g4");
		t.almacenarMovimiento("g2-g4");
		dev = t.mover('n', 4, 1, 3, 2, "h4", "g3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraGF() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 2, 5, 2, "g7", "g5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 2, 4, 2, "g5", "g4");
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.almacenarMovimiento("f2-f4");
		dev = t.mover('n', 4, 2, 3, 3, "g4", "f3");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoDerechaNegraFE() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.almacenarMovimiento("e2-e4");
		dev = t.mover('n', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(4, dev);
	} 
	
	public void testPeonComerAlPasoDerechaNegraED() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 5, 4, 5, "d2", "d4");
		t.almacenarMovimiento("d2-d4");
		dev = t.mover('n', 4, 4, 3, 5, "e4", "d3");
		
		
		super.assertEquals(4, dev);
	}
	
	
	public void testPeonComerAlPasoDerechaNegraDC() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 5, 4, 5, "d5", "d4");
		t.mover('b', 2, 6, 4, 6, "c2", "c4");
		t.almacenarMovimiento("c2-c4");
		dev = t.mover('n', 4, 5, 3, 6, "d4", "c3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraCB() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 6, 5, 6, "c7", "c5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 6, 4, 6, "c5", "c4");
		t.mover('b', 2, 7, 4, 7, "b2", "b4");
		t.almacenarMovimiento("b2-b4");
		dev = t.mover('n', 4, 6, 3, 7, "c4", "b3");
		
		
		super.assertEquals(4, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraBA() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 7, 5, 7, "b7", "b5");
		t.mover('b', 2, 1, 3, 1, "h2", "h3");
		t.mover('n', 5, 7, 4, 7, "b5", "b4");
		t.mover('b', 2, 8, 4, 8, "a2", "a4");
		t.almacenarMovimiento("a2-a4");
		dev = t.mover('n', 4, 7, 3, 8, "b4", "a3");
		
		
		super.assertEquals(4, dev);
	}
}
