package ajedrez.server.persistencia;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Vector;

import ajedrez.client.comunicaciones.IJugador;
import ajedrez.client.comunicaciones.Jugador;
import ajedrez.client.presen.IVentanaTablero;
import ajedrez.server.comunicaciones.AjedrezServer;
import ajedrez.server.presen.FVentanaServidor;
import ajedrez.server.presen.JFLanzadorServer;

import junit.framework.TestCase;

public class TestCubrirAjedrezServer extends TestCase {

	
	private class StubJugador implements IJugador{

		String name;
		
		
		public StubJugador(String n){
			this.name = n;
		}
		
		@Override
		public void MostrarInfoAbandono() throws RemoteException {
			// TODO Auto-generated method stub
			
		}

		
		Vector se = new Vector();
		public void RellenerSalaEspera(Vector arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.addAll(arg0);
		}

		
		int a1;
		String a2;
		String a3;
		public void actualizar(int arg0, String arg1, String arg2)
				throws RemoteException {
			// TODO Auto-generated method stub
			a1=arg0;
			a2=arg1;
			a3=arg2;
		}

		@Override
		public void borrarJugSalaEspera(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.remove(arg0);
		}

		@Override
		public void cierreForzoso() throws RemoteException {
			// TODO Auto-generated method stub
			
		}

		int ctR;
		char ctRC;
		@Override
		public void contestarReto(int arg0, char arg1) throws RemoteException {
			// TODO Auto-generated method stub
			ctR=arg0;
			ctRC=arg1;
		}

		boolean ctt;
		@Override
		public void contestarTablas(boolean arg0) throws RemoteException {
			// TODO Auto-generated method stub
			ctt=arg0;
		}

		@Override
		public String getNombre() throws RemoteException {
			// TODO Auto-generated method stub
			return this.name;
		}

		String nJ;
		@Override
		public void mostrarJugadorNuevo(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			nJ=arg0;
		}

		@Override
		public void proponerTablas() throws RemoteException {
			// TODO Auto-generated method stub
			
		}

		String retar;
		@Override
		public void retar(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			retar = arg0;
		}

		int rc1;
		int rc2;
		char rcC;
		@Override
		public void rivalCorono(int arg0, int arg1, char arg2)
				throws RemoteException {
			// TODO Auto-generated method stub
			rc1 = arg0;
			rc2 = arg1;
			rcC = arg2;
		}

		IVentanaTablero t;
		@Override
		public void setTablero(IVentanaTablero arg0) throws RemoteException {
			// TODO Auto-generated method stub
			t = arg0;
		}
		
	}
	
	private AjedrezServer as;
	private FVentanaServidor vs;
	
	
	String user1 = "test1";
	String user2 = "test2";
	String pass1 = "pass1";
	String pass2 = "pass2";
	
	Vector<String> partidaInserted;
	Vector<String> jugadorInserted;
	
	protected void setUp(){
		
		try {
			as = new AjedrezServer();
			vs = new FVentanaServidor(as);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		partidaInserted = new Vector<String>();
		jugadorInserted = new Vector<String>();
		PreparedStatement p = null;
		Connection bd = null;
		String SQL = "INSERT INTO Jugador (nombreUsuario, contrasea, [Partidas Jugadas], [Partidas Ganadas], [Partidas Perdidas], [Partidas Tablas], Puntuacion) values (?, ?, ?, ?, ?, ?, ?)";
		
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL);
			p.setString(1, user1);
			p.setString(2, pass1);
			p.setInt(3, 0);
			p.setInt(4, 0);
			p.setInt(5, 0);
			p.setInt(6, 0);
			p.setInt(7, 0);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL);
			p.setString(1, user2);
			p.setString(2, pass2);
			p.setInt(3, 0);
			p.setInt(4, 0);
			p.setInt(5, 0);
			p.setInt(6, 0);
			p.setInt(7, 0);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
	}
	protected void tearDown(){
		PreparedStatement p = null;
		Connection bd = null;
		
		String SQL4 = "Delete from Jugador WHERE nombreUsuario = ?;";
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL4);
			p.setString(1, user1);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL4);
			p.setString(1, user2);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
		if(this.partidaInserted.size()>0){
			for(String part : partidaInserted){
				String SQL1 = "Delete from [Historial Partidas]  where [Id Partida] = ?;";
				try {
					bd = Agente.getAgente().getBD();
					p = bd.prepareStatement(SQL1);
					p.setString(1, part);
					p.executeUpdate();
				}
				catch (SQLException eSQL) {
					eSQL.printStackTrace(); 
				}
				finally {
					try {
						bd.close();
					}
					catch (SQLException eSQL) {
						eSQL.printStackTrace();
					}
				}
			}
			
			
		}
		
		if(this.jugadorInserted.size()>0){
			for(String jug:jugadorInserted){
				try {
					bd = Agente.getAgente().getBD();
					p = bd.prepareStatement(SQL4);
					p.setString(1, jug);
					p.executeUpdate();
				}
				catch (SQLException eSQL) {
					eSQL.printStackTrace(); 
				}
				finally {
					try {
						bd.close();
					}
					catch (SQLException eSQL) {
						eSQL.printStackTrace();
					}
				}
			}
			
		}
		
	}
	
	public void testGetJCVacio(){
		try {
			Vector<String> v = as.getJugadoresConectados();
			assertTrue(v.size()==0);
		} catch (RemoteException e) {
			fail();
		}
		
	}
	
	public void testGetClasificacion(){
		try {
			String [] res = as.getClasificacion(this.user1);
			for(String r:res){
				assertTrue(r,r.equals("0"));
			}
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void testGetClasificacionMal(){
		try {
			String [] res = as.getClasificacion("mal");
			for(String r:res){
				assertTrue(r,r==null);
			}
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void testRegistrar(){
		String idJ = "test3";
		this.jugadorInserted.add(idJ);
		try {
			boolean r = as.registrar(idJ, "pass1");
			assertTrue(r == true);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void testRegistrarMal(){
		
		try {
			boolean r = as.registrar(this.user1, "pass1");
			assertTrue(r+"",r == false);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	public void testIdentificarCorrecto(){
		
		try {
			int r = this.as.identificar(this.user1, this.pass1);
			assertTrue(r+"", r == 0);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	public void testIdentificarPassMal(){
		
		try {
			int r = this.as.identificar(this.user1, "EstaMal");
			assertTrue(r+"", r == -1);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	public void testIdentificarUserMal(){
		
		try {
			int r = this.as.identificar("EstaMal", "EstaMal");
			assertTrue(r+"", r == -2);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testIdentificarDosVeces(){
		StubJugador j = new StubJugador(this.user1);
		try {
			as.identificar(user1, j);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		try {
			int r = this.as.identificar(this.user1, this.pass1);
			assertTrue(r+"", r == -3);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	public void testIdentificarVarios(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}
	
	public void testIdentificarDosVecesElmismo(){
		StubJugador j = new StubJugador(this.user1);
		
		try {
			as.identificar(user1, j);
			as.identificar(user1, j);
			
			assertTrue(as.getJugadoresConectados().size()+"",as.getJugadoresConectados().size()==1);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}
	
	public void testCerrarSession(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
			as.cerrarSesion("j3");
			assertTrue(as.getJugadoresConectados().size()==3);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testCerrarSessionMal(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
			as.cerrarSesion("j5");
			assertTrue(as.getJugadoresConectados().size()==4);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testRetar(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
			as.retar(this.user1, this.user2);
			
			assertTrue(j2.retar.equals(this.user1));
			
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	
	/*public void testAceptarReto(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
			as.contestarReto(this.user1, this.user2, true);
			assertTrue(as.getJugadoresConectados().size()==2);
			assertTrue(j.ctR==j2.ctR);
			
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}*/
	
	public void testAceptarRetofalse(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
			as.contestarReto(this.user1, this.user2, false);
			assertTrue(as.getJugadoresConectados().size()==4);
			assertTrue(j.ctR==0);
			assertTrue(j2.ctR==-1);
			
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
}

