package ajedrez.server.persistencia;

import java.net.MalformedURLException;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Vector;

import ajedrez.client.comunicaciones.IJugador;
import ajedrez.client.comunicaciones.Jugador;
import ajedrez.client.presen.IVentanaTablero;
import ajedrez.server.comunicaciones.AjedrezServer;
import ajedrez.server.presen.FVentanaServidor;
import ajedrez.server.presen.JFLanzadorServer;

import junit.framework.TestCase;

public class TestCubrirAjedrezServerConexion extends TestCase {

	
	private class StubJugador implements IJugador{

		String name;
		
		
		public StubJugador(String n){
			this.name = n;
		}
		
		@Override
		public void MostrarInfoAbandono() throws RemoteException {
			// TODO Auto-generated method stub
			
		}

		
		Vector se = new Vector();
		public void RellenerSalaEspera(Vector arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.addAll(arg0);
		}

		
		int a1;
		String a2;
		String a3;
		public void actualizar(int arg0, String arg1, String arg2)
				throws RemoteException {
			// TODO Auto-generated method stub
			a1=arg0;
			a2=arg1;
			a3=arg2;
		}

		@Override
		public void borrarJugSalaEspera(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.remove(arg0);
		}

		@Override
		public void cierreForzoso() throws RemoteException {
			// TODO Auto-generated method stub
			
		}

		int ctR;
		char ctRC;
		@Override
		public void contestarReto(int arg0, char arg1) throws RemoteException {
			// TODO Auto-generated method stub
			ctR=arg0;
			ctRC=arg1;
		}

		boolean ctt;
		@Override
		public void contestarTablas(boolean arg0) throws RemoteException {
			// TODO Auto-generated method stub
			ctt=arg0;
		}

		@Override
		public String getNombre() throws RemoteException {
			// TODO Auto-generated method stub
			return this.name;
		}

		String nJ;
		@Override
		public void mostrarJugadorNuevo(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			nJ=arg0;
		}

		@Override
		public void proponerTablas() throws RemoteException {
			// TODO Auto-generated method stub
			
		}

		String retar;
		@Override
		public void retar(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			retar = arg0;
		}

		int rc1;
		int rc2;
		char rcC;
		@Override
		public void rivalCorono(int arg0, int arg1, char arg2)
				throws RemoteException {
			// TODO Auto-generated method stub
			rc1 = arg0;
			rc2 = arg1;
			rcC = arg2;
		}

		IVentanaTablero t;
		@Override
		public void setTablero(IVentanaTablero arg0) throws RemoteException {
			// TODO Auto-generated method stub
			t = arg0;
		}
		
	}
	
	private AjedrezServer as;
	private FVentanaServidor vs;
	
	
	String user1 = "test1";
	String user2 = "test2";
	String pass1 = "pass1";
	String pass2 = "pass2";
	
	Vector<String> partidaInserted;
	Vector<String> jugadorInserted;
	
	protected void setUp(){
		
		try {
			as = new AjedrezServer();
			vs = new FVentanaServidor(as);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		partidaInserted = new Vector<String>();
		jugadorInserted = new Vector<String>();
		PreparedStatement p = null;
		Connection bd = null;
		String SQL = "INSERT INTO Jugador (nombreUsuario, contrasea, [Partidas Jugadas], [Partidas Ganadas], [Partidas Perdidas], [Partidas Tablas], Puntuacion) values (?, ?, ?, ?, ?, ?, ?)";
		
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL);
			p.setString(1, user1);
			p.setString(2, pass1);
			p.setInt(3, 0);
			p.setInt(4, 0);
			p.setInt(5, 0);
			p.setInt(6, 0);
			p.setInt(7, 0);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL);
			p.setString(1, user2);
			p.setString(2, pass2);
			p.setInt(3, 0);
			p.setInt(4, 0);
			p.setInt(5, 0);
			p.setInt(6, 0);
			p.setInt(7, 0);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
	}
	protected void tearDown(){
		PreparedStatement p = null;
		Connection bd = null;
		
		String SQL4 = "Delete from Jugador WHERE nombreUsuario = ?;";
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL4);
			p.setString(1, user1);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
		try {
			bd = Agente.getAgente().getBD();
			p = bd.prepareStatement(SQL4);
			p.setString(1, user2);
			p.executeUpdate();
		}
		catch (SQLException eSQL) {
			eSQL.printStackTrace(); 
		}
		finally {
			try {
				bd.close();
			}
			catch (SQLException eSQL) {
				eSQL.printStackTrace();
			}
		}
		
		if(this.partidaInserted.size()>0){
			for(String part : partidaInserted){
				String SQL1 = "Delete from [Historial Partidas]  where [Id Partida] = ?;";
				try {
					bd = Agente.getAgente().getBD();
					p = bd.prepareStatement(SQL1);
					p.setString(1, part);
					p.executeUpdate();
				}
				catch (SQLException eSQL) {
					eSQL.printStackTrace(); 
				}
				finally {
					try {
						bd.close();
					}
					catch (SQLException eSQL) {
						eSQL.printStackTrace();
					}
				}
			}
			
			
		}
		
		if(this.jugadorInserted.size()>0){
			for(String jug:jugadorInserted){
				try {
					bd = Agente.getAgente().getBD();
					p = bd.prepareStatement(SQL4);
					p.setString(1, jug);
					p.executeUpdate();
				}
				catch (SQLException eSQL) {
					eSQL.printStackTrace(); 
				}
				finally {
					try {
						bd.close();
					}
					catch (SQLException eSQL) {
						eSQL.printStackTrace();
					}
				}
			}
			
		}
		
	}
	
	
	
	
	
	
	
	public void testConectarDesconectar(){
		try {
			this.as.conectar("127.0.0.1", 12345);
			as.desconectarServidor();
		} catch (MalformedURLException e) {
			fail();
		} catch (RemoteException e) {
			fail();
		}
		
	}
	
	public void testDesconectarJugadores(){
		StubJugador j = new StubJugador(this.user1);
		StubJugador j2 = new StubJugador(this.user2);
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar(user1, j);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
			as.desconectarJugadores(); 
			
			assertTrue(as.getJugadoresConectados().size()==4);
			
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}

	
	public void testConectarDesconectarDos(){
		try {
			this.as.conectar("127.0.0.1", 12345);
			
			
			try{
				AjedrezServer as2 = new AjedrezServer();
				FVentanaServidor fvs2 = new FVentanaServidor(as2);
				as2.conectar("127.0.0.1", 12345);
				fail();
			}catch(Exception e){
				//e.printStackTrace();
			}
			
			as.desconectarServidor();
		} catch (MalformedURLException e) {
			fail();
		} catch (RemoteException e) {
			e.printStackTrace();
			fail();
		}
		
	}
	
	
	
}

