package ajedrez.server.presen;


import java.awt.Frame;
import java.awt.Label;
import java.awt.List;
import java.awt.Rectangle;
import java.rmi.RemoteException;
import javax.swing.JButton;
import javax.swing.JOptionPane;

import ajedrez.server.comunicaciones.AjedrezServer;


/* Clase visual que muestra el servidor conectado. */
public class FVentanaServidor extends Frame {
	private static final long serialVersionUID = 1L;
	private Label labelJugadores = null;
	private List listJugadores = null;
	private Label labelMensajes = null;
	private List listMensajes = null;
	private JButton jButtonDesconectar = null;
	private AjedrezServer servidor = null;
	
	
	/**
	 * This is the default constructor.
	 */
	public FVentanaServidor(AjedrezServer servidor) {
		super();
		initialize();
		this.servidor = servidor;
		servidor.setInterfaz(this);
	} /* Fin constructor */
	
	
	/**
	 * This method initializes this.
	 * @return   void
	 */
	private void initialize() {
		labelMensajes = new Label();
		labelMensajes.setBounds(new Rectangle(349, 40, 169, 25));
		labelMensajes.setText("MENSAJES DEL PROGRAMA");
		labelJugadores = new Label();
		labelJugadores.setBounds(new Rectangle(18, 39, 169, 24));
		labelJugadores.setText("JUGADORES CONECTADOS");
		this.setLayout(null);
		this.setSize(663, 283);
		this.setResizable(false);
		this.setTitle("Servidor");
		this.add(labelJugadores, null);
		this.add(getListJugadores(), null);
		this.add(labelMensajes, null);
		this.add(getListMensajes(), null);
		this.add(getJButtonDesconectar(), null);
		final Frame ventanaActual = this;
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				cerrarVentana(ventanaActual);
			}
		});
	} /* Fin mtodo initialize */
	
	
	/**
	 * This method initializes listJugadores.
	 * @return   java.awt.List
	 */
	private List getListJugadores() {
		if (listJugadores == null) {
			listJugadores = new List();
			listJugadores.setBounds(new Rectangle(22, 69, 162, 149));
			listJugadores.setEnabled(true);
		}
		return listJugadores;
	} /* Fin mtodo getListJugadores */
	
	
	/**
	 * This method initializes listMensajes.
	 * @return   java.awt.List
	 */
	private List getListMensajes() {
		if (listMensajes == null) {
			listMensajes = new List();
			listMensajes.setBounds(new Rectangle(201, 69, 438, 150));
			listMensajes.setEnabled(true);
		}
		return listMensajes;
	} /* Fin mtodo getListMensajes */
	
	
	/**
	 * This method initializes jButtonDesconectar.
	 * @return   javax.swing.JButton
	 */
	private JButton getJButtonDesconectar() {
		final Frame ventanaActual = this;
		if (jButtonDesconectar == null) {
			jButtonDesconectar = new JButton();
			jButtonDesconectar.setBounds(new Rectangle(281, 231, 110, 39));
			jButtonDesconectar.setText("Desconectar");
			jButtonDesconectar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cerrarVentana(ventanaActual);
				}
			});
		}
		return jButtonDesconectar;
	} /* Fin mtodo getJButtonDesconectar */
	
	
	/**
	 * Realiza todo el proceso necesario para cerrar la ventana.
	 */
	private void cerrarVentana(Frame ventanaActual) {
		if (JOptionPane.showConfirmDialog(ventanaActual, "Se va a desconectar el servidor. Est seguro?", "Cerrar servidor", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
			try {
				servidor.desconectarJugadores();
				servidor.desconectarServidor();
			}
			catch (RemoteException eR) {
				//eR.printStackTrace();
				JOptionPane.showMessageDialog(ventanaActual, "Hubo un error en la desconexin del servicio de RMI.", "Error en la desconexin del servicio de RMI", JOptionPane.ERROR_MESSAGE);
			}
			ventanaActual.dispose();
			System.exit(0);
		}
	} /* Fin mtodo cerrarVentana */
	
	
	/**
	 * Aade un jugador al objeto listJugadores de jugadores conectados.
	 */
	public void aadeJugador(String sNombreUsuario) {
		listJugadores.add(sNombreUsuario);
	} /* Fin mtodo aadeJugador */
	
	
	/**
	 * Elimina un jugador del objeto listJugadores de jugadores conectados.
	 */
	public void eliminaJugador(String sNombreUsuario) {
		listJugadores.remove(sNombreUsuario);
	} /* Fin mtodo eliminaJugador */
	
	
	/**
	 * Aade un nuevo mensaje al objeto listMensajes de mensajes del programa.
	 */
	public void aadeMensaje(String sMensaje) {
		listMensajes.add(sMensaje, 0);
	} /* Fin mtodo aadeMensaje */
	
//  @jve:decl-index=0:visual-constraint="10,10"
} /* Fin clase visual FVentanaServidor */
